
Ruby - Feature #5778

Allow WEBrick::HTTPResponse to send IO-duck-typed bodies

12/20/2011 02:02 AM - regularfry (Alex Young)

Status: Closed   

Priority: Normal   

Assignee: normalperson (Eric Wong)   

Target version:    

Description

WEBrick::HTTPResponse currently type-checks for IO to determine how to transfer content to the outgoing socket.  Because of this,

it's not possible to use "IO-like" objects as data sources unless they specifically inherit from IO.

The interface HTTPResponse requires from its body objects is very simple: it only calls #read and #close, and optionally #bytesize. 

This means that the type-check is needlessly strict, and prevents custom objects from being used as data sources.  The attached

patch removes the type-check on IO, allowing duck-typed objects to be used.

The downside to this patch is that you can't pass in objects that duck-type to String's interface.  It wouldn't be hard to remove that

restriction if necessary, but I figured this was the less intrusive approach.

History

#1 - 03/29/2012 01:31 AM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to mame (Yusuke Endoh)

It is trivial, and the patch looks good to me.

I'll commit it unless there is objection.

--

Yusuke Endoh mame@tsg.ne.jp

#2 - 03/29/2012 11:27 AM - nahi (Hiroshi Nakamura)

Yusuke, you may want to assign it to me (maintainer)

I think it's good to improve, but not yet checked the patch...

#3 - 03/29/2012 11:57 PM - mame (Yusuke Endoh)

- Assignee changed from mame (Yusuke Endoh) to nahi (Hiroshi Nakamura)

You have control.

--

Yusuke Endoh mame@tsg.ne.jp

#4 - 11/20/2012 10:02 PM - mame (Yusuke Endoh)

- Target version set to 2.6

Blame NaHi!

--

Yusuke Endoh mame@tsg.ne.jp

#5 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)

- Target version deleted (2.6)

#6 - 06/20/2018 01:53 PM - mame (Yusuke Endoh)

- Assignee changed from nahi (Hiroshi Nakamura) to normalperson (Eric Wong)

@normalperson (Eric Wong), could you handle this ticket?
#7 - 06/23/2018 09:03 AM - normalperson (Eric Wong)

mame@ruby-lang.org wrote:

@normalperson (Eric Wong), could you handle this ticket?

https://bugs.ruby-lang.org/issues/5778#change-72539

 This seems identical to [Feature #8155] and already implemented.

https://bugs.ruby-lang.org/issues/8155

#8 - 11/30/2021 11:46 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Assigned to Closed

webrick is removed from ruby repo since Ruby 3.0.

The canonical repo is here: https://github.com/ruby/webrick/

Files

httpresponse.patch 2.76 KB 12/20/2011 regularfry (Alex Young)
